import { Component, Directive, Input, NgModule } from "@angular/core";
import { IgxButtonModule } from "../directives/button/button.directive";
/**
 * IgxCardHeader is container for the card header
 */
var IgxCardHeaderDirective = /** @class */ (function () {
    function IgxCardHeaderDirective() {
    }
    IgxCardHeaderDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: "igx-card-header"
                },] },
    ];
    /** @nocollapse */
    IgxCardHeaderDirective.ctorParameters = function () { return []; };
    return IgxCardHeaderDirective;
}());
export { IgxCardHeaderDirective };
/**
 * IgxCardContent is container for the card content
 */
var IgxCardContentDirective = /** @class */ (function () {
    function IgxCardContentDirective() {
    }
    IgxCardContentDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: "igx-card-content"
                },] },
    ];
    /** @nocollapse */
    IgxCardContentDirective.ctorParameters = function () { return []; };
    return IgxCardContentDirective;
}());
export { IgxCardContentDirective };
/**
 * IgxCardActions is container for the card actions
 */
var IgxCardActionsDirective = /** @class */ (function () {
    function IgxCardActionsDirective() {
    }
    IgxCardActionsDirective.decorators = [
        { type: Directive, args: [{
                    // tslint:disable-next-line:directive-selector
                    selector: "igx-card-actions"
                },] },
    ];
    /** @nocollapse */
    IgxCardActionsDirective.ctorParameters = function () { return []; };
    return IgxCardActionsDirective;
}());
export { IgxCardActionsDirective };
/**
 * IgxCardFooter is container for the card footer
 */
var IgxCardFooterDirective = /** @class */ (function () {
    function IgxCardFooterDirective() {
        this.role = "footer";
    }
    IgxCardFooterDirective.decorators = [
        { type: Directive, args: [{
                    /*     host: {
                                role: "footer"
                            }, */
                    // tslint:disable-next-line:directive-selector
                    selector: "igx-card-footer"
                },] },
    ];
    /** @nocollapse */
    IgxCardFooterDirective.ctorParameters = function () { return []; };
    IgxCardFooterDirective.propDecorators = {
        "role": [{ type: Input },],
    };
    return IgxCardFooterDirective;
}());
export { IgxCardFooterDirective };
/**
 * IgxCardComponent is a sheet of material that serves as an entry point to more detailed information.
 */
var IgxCardComponent = /** @class */ (function () {
    function IgxCardComponent() {
    }
    IgxCardComponent.decorators = [
        { type: Component, args: [{
                    selector: "igx-card",
                    template: "<div class=\"igx-card\" role=\"group\">     <ng-content></ng-content> </div>"
                },] },
    ];
    /** @nocollapse */
    IgxCardComponent.ctorParameters = function () { return []; };
    return IgxCardComponent;
}());
export { IgxCardComponent };
var IgxCardModule = /** @class */ (function () {
    function IgxCardModule() {
    }
    IgxCardModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxCardComponent, IgxCardHeaderDirective,
                        IgxCardContentDirective, IgxCardActionsDirective, IgxCardFooterDirective],
                    exports: [IgxCardComponent, IgxCardHeaderDirective,
                        IgxCardContentDirective, IgxCardActionsDirective, IgxCardFooterDirective],
                    imports: [IgxButtonModule]
                },] },
    ];
    /** @nocollapse */
    IgxCardModule.ctorParameters = function () { return []; };
    return IgxCardModule;
}());
export { IgxCardModule };
//# sourceMappingURL=card.component.js.map