import { CommonModule } from "@angular/common";
import { Directive, ElementRef, HostBinding, HostListener, NgModule } from "@angular/core";
var IgxInputDirective = /** @class */ (function () {
    function IgxInputDirective(el) {
        this.el = el;
        this.isInput = true;
        this.focused = false;
        this.filled = false;
        this.placeholder = false;
    }
    IgxInputDirective.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxInputDirective.prototype.onBlur = function (event) {
        this.focused = false;
    };
    IgxInputDirective.prototype.ngDoCheck = function () {
        var value = this.el.nativeElement.value;
        this.filled = value && (value !== "");
        this.placeholder = this.el.nativeElement.getAttribute("placeholder") && !this.filled;
    };
    IgxInputDirective.decorators = [
        { type: Directive, args: [{
                    selector: "[igxInput]"
                },] },
    ];
    /** @nocollapse */
    IgxInputDirective.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    IgxInputDirective.propDecorators = {
        "isInput": [{ type: HostBinding, args: ["class.igx-form-group__input",] },],
        "focused": [{ type: HostBinding, args: ["class.igx-form-group__input--focused",] },],
        "filled": [{ type: HostBinding, args: ["class.igx-form-group__input--filled",] },],
        "placeholder": [{ type: HostBinding, args: ["class.igx-form-group__input--placeholder",] },],
        "onFocus": [{ type: HostListener, args: ["focus", ["$event"],] },],
        "onBlur": [{ type: HostListener, args: ["blur", ["$event"],] },],
    };
    return IgxInputDirective;
}());
export { IgxInputDirective };
var IgxInputModule = /** @class */ (function () {
    function IgxInputModule() {
    }
    IgxInputModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxInputDirective],
                    exports: [IgxInputDirective],
                    imports: [CommonModule]
                },] },
    ];
    /** @nocollapse */
    IgxInputModule.ctorParameters = function () { return []; };
    return IgxInputModule;
}());
export { IgxInputModule };
//# sourceMappingURL=input.directive.js.map