var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ChangeDetectionStrategy, ChangeDetectorRef, Component, ElementRef, HostBinding, HostListener, Input, TemplateRef, ViewChild } from "@angular/core";
import { take } from "rxjs/operators";
import { DataType } from "../data-operations/data-util";
import { IgxGridAPIService } from "./api.service";
import { IgxColumnComponent } from "./column.component";
import { autoWire } from "./grid.common";
var IgxGridCellComponent = /** @class */ (function () {
    function IgxGridCellComponent(gridAPI, cdr, element) {
        this.gridAPI = gridAPI;
        this.cdr = cdr;
        this.element = element;
        this.tabindex = 0;
        this.role = "gridcell";
        this.defaultCssClass = "igx-grid__td";
        this.isFocused = false;
        this.isSelected = false;
        this._inEditMode = false;
    }
    Object.defineProperty(IgxGridCellComponent.prototype, "formatter", {
        get: function () {
            return this.column.formatter;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "context", {
        get: function () {
            return {
                $implicit: this.value,
                cell: this
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "template", {
        get: function () {
            if (this.inEditMode) {
                var inlineEditorTemplate = this.column.inlineEditorTemplate;
                return inlineEditorTemplate ? inlineEditorTemplate : this.inlineEditorTemplate;
            }
            if (this.cellTemplate) {
                return this.cellTemplate;
            }
            return this.defaultCellTemplate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "gridID", {
        get: function () {
            return this.row.gridID;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "grid", {
        get: function () {
            return this.gridAPI.get(this.gridID);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "rowIndex", {
        get: function () {
            return this.row.index;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "columnIndex", {
        get: function () {
            return this.column.index;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "visibleColumnIndex", {
        get: function () {
            return this.column.visibleIndex;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "nativeElement", {
        get: function () {
            return this.element.nativeElement;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "inEditMode", {
        get: function () {
            return this._inEditMode;
        },
        set: function (value) {
            this._inEditMode = value;
            if (this._inEditMode) {
                this.grid.cellInEditMode = this;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "readonly", {
        get: function () {
            return !this.column.editable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "describedby", {
        get: function () {
            return this.row.gridID + "_" + this.column.field;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "styleClasses", {
        get: function () {
            return this.defaultCssClass + " " + this.column.cellClasses;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "width", {
        get: function () {
            return this.column.width;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "editModeCSS", {
        get: function () {
            return this._inEditMode;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "focused", {
        get: function () {
            return this.isFocused || this.isSelected;
        },
        set: function (val) {
            this.isFocused = val;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "applyNumberCSSClass", {
        get: function () {
            return this.column.dataType === DataType.Number;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "isPinned", {
        get: function () {
            return this.column.pinned;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "isLastPinned", {
        get: function () {
            var pinnedCols = this.grid.pinnedColumns;
            if (pinnedCols.length === 0) {
                return false;
            }
            else {
                return pinnedCols.indexOf(this.column) === pinnedCols.length - 1;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IgxGridCellComponent.prototype, "selected", {
        get: function () {
            return this.isSelected;
        },
        set: function (val) {
            this.isSelected = val;
        },
        enumerable: true,
        configurable: true
    });
    IgxGridCellComponent.prototype.ngOnInit = function () {
    };
    IgxGridCellComponent.prototype.update = function (val) {
        this.grid.onEditDone.emit({ cell: this, currentValue: this.value, newValue: val });
        this.value = val;
        this.gridAPI.update(this.gridID, this);
    };
    IgxGridCellComponent.prototype.onDoubleClick = function (event) {
        if (this.column.editable) {
            this.inEditMode = true;
        }
    };
    IgxGridCellComponent.prototype.onFocus = function (event) {
        this.isFocused = true;
        this.isSelected = true;
        this.row.focused = true;
        if (this.grid.cellInEditMode && this.grid.cellInEditMode !== this) {
            this.grid.cellInEditMode.inEditMode = false;
            this.grid.cellInEditMode = null;
        }
        this.grid.onSelection.emit(this);
        this.syncRows();
    };
    IgxGridCellComponent.prototype.onBlur = function (event) {
        this.isFocused = false;
        this.isSelected = false;
        this.row.focused = false;
    };
    IgxGridCellComponent.prototype.onKeydownArrowLeft = function (event) {
        var _this = this;
        event.preventDefault();
        var visibleColumns = this.grid.visibleColumns;
        var rowIndex = this.rowIndex;
        var visibleColumnIndex = this.visibleColumnIndex - 1;
        if (visibleColumnIndex >= 0) {
            var target = this.gridAPI.get_cell_by_visible_index(this.gridID, rowIndex, visibleColumnIndex);
            if (target) {
                target.nativeElement.focus();
                this.syncRows();
            }
            else {
                if (!this.column.pinned) {
                    this.row.virtDirRow.scrollPrev();
                }
                else {
                    this.row.virtDirRow.scrollTo(this.grid.unpinnedColumns.length - 1);
                }
                this.row.virtDirRow.onChunkLoad.pipe(take(1)).subscribe({
                    next: function (e) {
                        _this.row.cdr.detectChanges();
                        var currTarget = _this.gridAPI.get_cell_by_visible_index(_this.gridID, rowIndex, visibleColumnIndex);
                        if (currTarget) {
                            currTarget.nativeElement.focus();
                        }
                        else {
                            _this.row.cells.first.nativeElement.focus();
                        }
                        setTimeout(function () {
                            _this.syncRows();
                        });
                    }
                });
            }
        }
    };
    IgxGridCellComponent.prototype.onKeydownCtrlArrowLeft = function () {
        var target = this.gridAPI.get_cell_by_visible_index(this.gridID, this.rowIndex, this.row.cells.first.visibleColumnIndex);
        if (target) {
            target.nativeElement.focus();
            this.syncRows();
        }
    };
    IgxGridCellComponent.prototype.onKeydownArrowRight = function (event) {
        var _this = this;
        event.preventDefault();
        var visibleColumns = this.grid.visibleColumns;
        var rowIndex = this.rowIndex;
        var visibleColumnIndex = this.visibleColumnIndex + 1;
        if (visibleColumnIndex > -1 && visibleColumnIndex <= visibleColumns.length - 1) {
            var target = this.gridAPI.get_cell_by_visible_index(this.gridID, rowIndex, visibleColumnIndex);
            if (target) {
                target.nativeElement.focus();
                this.syncRows();
            }
            else {
                if (!this.column.pinned) {
                    this.row.virtDirRow.scrollNext();
                }
                else {
                    this.row.virtDirRow.scrollTo(0);
                }
                this.row.virtDirRow.onChunkLoad.pipe(take(1)).subscribe({
                    next: function (e) {
                        _this.row.cdr.detectChanges();
                        var currTarget = _this.gridAPI.get_cell_by_visible_index(_this.gridID, rowIndex, visibleColumnIndex);
                        if (currTarget) {
                            currTarget.nativeElement.focus();
                        }
                        else {
                            _this.row.cells.last.nativeElement.focus();
                        }
                        setTimeout(function () {
                            _this.syncRows();
                        });
                    }
                });
            }
        }
    };
    IgxGridCellComponent.prototype.onKeydownCtrlArrowRight = function () {
        var target = this.gridAPI.get_cell_by_visible_index(this.gridID, this.rowIndex, this.row.cells.last.visibleColumnIndex);
        if (target) {
            target.nativeElement.focus();
            this.syncRows();
        }
    };
    IgxGridCellComponent.prototype.onKeydownArrowUp = function (event) {
        event.preventDefault();
        var target = this.gridAPI.get_cell_by_visible_index(this.gridID, this.rowIndex - 1, this.visibleColumnIndex);
        if (target) {
            target.nativeElement.focus();
        }
        else {
            this.row.grid.verticalScrollContainer.scrollPrev();
        }
    };
    IgxGridCellComponent.prototype.onKeydownArrowDown = function (event) {
        event.preventDefault();
        var target = this.gridAPI.get_cell_by_visible_index(this.gridID, this.rowIndex + 1, this.visibleColumnIndex);
        if (target) {
            target.nativeElement.focus();
        }
        else {
            this.row.grid.verticalScrollContainer.scrollNext();
        }
    };
    IgxGridCellComponent.prototype.onKeydownEnterEditMode = function () {
        if (this.column.editable) {
            this.inEditMode = !this.inEditMode;
        }
    };
    IgxGridCellComponent.prototype.onKeydownExitEditMode = function () {
        this.inEditMode = false;
    };
    IgxGridCellComponent.prototype.syncRows = function () {
        var scrLeft = this.row.virtDirRow.dc.instance._viewContainer.element.nativeElement.scrollLeft;
        var headerDcElem = this.grid.headerContainer.dc.instance._viewContainer.element.nativeElement;
        headerDcElem.style.left = (-scrLeft) + "px";
        this.row.grid.rowList.map(function (row) {
            var elem = row.virtDirRow.dc.instance._viewContainer.element.nativeElement;
            elem.scrollLeft = scrLeft;
            row.cdr.markForCheck();
        });
    };
    IgxGridCellComponent.decorators = [
        { type: Component, args: [{
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    preserveWhitespaces: false,
                    selector: "igx-grid-cell",
                    template: "<ng-template #defaultCell>     {{ formatter ? formatter(value) : value }} </ng-template> <ng-template #inlineEditor let-cell=\"cell\">     <input igxInput [value]=\"value\" (keydown.enter)=\"cell.update($event.target.value)\"> </ng-template> <ng-container *ngTemplateOutlet=\"template; context: context\"> </ng-container>"
                },] },
    ];
    /** @nocollapse */
    IgxGridCellComponent.ctorParameters = function () { return [
        { type: IgxGridAPIService, },
        { type: ChangeDetectorRef, },
        { type: ElementRef, },
    ]; };
    IgxGridCellComponent.propDecorators = {
        "column": [{ type: Input },],
        "row": [{ type: Input },],
        "cellTemplate": [{ type: Input },],
        "value": [{ type: Input },],
        "tabindex": [{ type: HostBinding, args: ["attr.tabindex",] },],
        "role": [{ type: HostBinding, args: ["attr.role",] },],
        "readonly": [{ type: HostBinding, args: ["attr.aria-readonly",] },],
        "describedby": [{ type: HostBinding, args: ["attr.aria-describedby",] },],
        "styleClasses": [{ type: HostBinding, args: ["class",] },],
        "width": [{ type: HostBinding, args: ["style.min-width",] }, { type: HostBinding, args: ["style.flex-basis",] }, { type: HostBinding, args: ["class.igx-grid__td--fw",] },],
        "editModeCSS": [{ type: HostBinding, args: ["class.igx-grid__td--editing",] },],
        "focused": [{ type: HostBinding, args: ["attr.aria-selected",] }, { type: HostBinding, args: ["class.igx-grid__td--selected",] },],
        "applyNumberCSSClass": [{ type: HostBinding, args: ["class.igx-grid__td--number",] },],
        "isLastPinned": [{ type: HostBinding, args: ["class.igx-grid__th--pinned-start",] },],
        "defaultCellTemplate": [{ type: ViewChild, args: ["defaultCell", { read: TemplateRef },] },],
        "inlineEditorTemplate": [{ type: ViewChild, args: ["inlineEditor", { read: TemplateRef },] },],
        "onDoubleClick": [{ type: HostListener, args: ["dblclick", ["$event"],] },],
        "onFocus": [{ type: HostListener, args: ["focus", ["$event"],] },],
        "onBlur": [{ type: HostListener, args: ["blur", ["$event"],] },],
        "onKeydownArrowLeft": [{ type: HostListener, args: ["keydown.arrowleft", ["$event"],] },],
        "onKeydownCtrlArrowLeft": [{ type: HostListener, args: ["keydown.control.arrowleft",] },],
        "onKeydownArrowRight": [{ type: HostListener, args: ["keydown.arrowright", ["$event"],] },],
        "onKeydownCtrlArrowRight": [{ type: HostListener, args: ["keydown.control.arrowright",] },],
        "onKeydownArrowUp": [{ type: HostListener, args: ["keydown.arrowup", ["$event"],] },],
        "onKeydownArrowDown": [{ type: HostListener, args: ["keydown.arrowdown", ["$event"],] },],
        "onKeydownEnterEditMode": [{ type: HostListener, args: ["keydown.enter",] }, { type: HostListener, args: ["keydown.f2",] },],
        "onKeydownExitEditMode": [{ type: HostListener, args: ["keydown.escape",] },],
    };
    __decorate([
        autoWire(true),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], IgxGridCellComponent.prototype, "inEditMode", null);
    __decorate([
        autoWire(true),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], IgxGridCellComponent.prototype, "focused", null);
    __decorate([
        autoWire(true),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [Boolean])
    ], IgxGridCellComponent.prototype, "selected", null);
    __decorate([
        autoWire(true),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], IgxGridCellComponent.prototype, "ngOnInit", null);
    __decorate([
        autoWire(true),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], IgxGridCellComponent.prototype, "update", null);
    __decorate([
        autoWire(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], IgxGridCellComponent.prototype, "onFocus", null);
    __decorate([
        autoWire(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], IgxGridCellComponent.prototype, "onBlur", null);
    __decorate([
        autoWire(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], IgxGridCellComponent.prototype, "syncRows", null);
    return IgxGridCellComponent;
}());
export { IgxGridCellComponent };
//# sourceMappingURL=cell.component.js.map