import { ChangeDetectorRef, ElementRef, OnDestroy, OnInit, QueryList } from "@angular/core";
import { IgxForOfDirective } from "../directives/for-of/for_of.directive";
import { IgxGridAPIService } from "./api.service";
import { IgxGridCellComponent } from "./cell.component";
import { IgxColumnComponent } from "./column.component";
import { IGridBus } from "./grid.common";
import { IgxGridComponent } from "./grid.component";
export declare class IgxGridRowComponent implements IGridBus, OnInit, OnDestroy {
    gridAPI: IgxGridAPIService;
    private element;
    cdr: ChangeDetectorRef;
    rowData: any[];
    index: number;
    gridID: string;
    virtDirRow: IgxForOfDirective<any>;
    cells: QueryList<IgxGridCellComponent>;
    readonly rowHeight: number;
    tabindex: number;
    role: string;
    readonly styleClasses: string;
    focused: boolean;
    readonly columns: IgxColumnComponent[];
    readonly pinnedColumns: IgxColumnComponent[];
    readonly unpinnedColumns: IgxColumnComponent[];
    readonly grid: IgxGridComponent;
    readonly nativeElement: any;
    protected defaultCssClass: string;
    protected isFocused: boolean;
    protected chunkLoaded$: any;
    constructor(gridAPI: IgxGridAPIService, element: ElementRef, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onFocus(event: any): void;
    onBlur(event: any): void;
}
