import { Component, EventEmitter, Input, NgModule, Output, ViewChild } from "@angular/core";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
var nextId = 0;
var noop = function () { };
var ɵ0 = noop;
var IgxRadioComponent = /** @class */ (function () {
    function IgxRadioComponent() {
        this.id = "igx-radio-" + nextId++;
        this.tabindex = null;
        this.change = new EventEmitter();
        this._onTouchedCallback = noop;
        this._onChangeCallback = noop;
    }
    Object.defineProperty(IgxRadioComponent.prototype, "checked", {
        get: function () {
            return this._checked;
        },
        set: function (value) {
            this._checked = value;
        },
        enumerable: true,
        configurable: true
    });
    IgxRadioComponent.prototype.onChange = function (event) {
        this.select();
        this.change.emit(event);
    };
    IgxRadioComponent.prototype.select = function () {
        this.checked = true;
        this._onChangeCallback(this.value);
    };
    IgxRadioComponent.prototype.writeValue = function (value) {
        this._value = value;
        this.checked = (this._value === this.value);
    };
    IgxRadioComponent.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxRadioComponent.prototype.onBlur = function (event) {
        this.focused = false;
        this._onTouchedCallback();
    };
    IgxRadioComponent.prototype.registerOnChange = function (fn) { this._onChangeCallback = fn; };
    IgxRadioComponent.prototype.registerOnTouched = function (fn) { this._onTouchedCallback = fn; };
    IgxRadioComponent.decorators = [
        { type: Component, args: [{
                    providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: IgxRadioComponent, multi: true }],
                    selector: "igx-radio",
                    template: "<div class=\"igx-control\">     <input class=\"igx-control__radio\" type=\"radio\" #radio         [attr.id]=\"id\"         [attr.name]=\"name\"         [attr.value]=\"value\"         [attr.tabindex]=\"tabindex\"         [attr.aria-checked]=\"checked\"         [disabled]=\"disabled\"         [checked]=\"checked\"         (change)=\"onChange($event)\"         (focus)=\"onFocus($event)\"         (blur)=\"onBlur($event)\"/>     <label class =\"igx-control__label\" [attr.for]=\"id\"><ng-content></ng-content></label> </div>"
                },] },
    ];
    /** @nocollapse */
    IgxRadioComponent.ctorParameters = function () { return []; };
    IgxRadioComponent.propDecorators = {
        "value": [{ type: Input },],
        "id": [{ type: Input },],
        "name": [{ type: Input },],
        "disabled": [{ type: Input },],
        "tabindex": [{ type: Input },],
        "change": [{ type: Output },],
        "nativeRadio": [{ type: ViewChild, args: ["radio",] },],
    };
    return IgxRadioComponent;
}());
export { IgxRadioComponent };
var IgxRadioModule = /** @class */ (function () {
    function IgxRadioModule() {
    }
    IgxRadioModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxRadioComponent],
                    exports: [IgxRadioComponent]
                },] },
    ];
    /** @nocollapse */
    IgxRadioModule.ctorParameters = function () { return []; };
    return IgxRadioModule;
}());
export { IgxRadioModule };
export { ɵ0 };
//# sourceMappingURL=radio.component.js.map