import { Component, EventEmitter, Input, NgModule, Output, ViewChild } from "@angular/core";
import { NG_VALUE_ACCESSOR } from "@angular/forms";
var noop = function () { };
var ɵ0 = noop;
var nextId = 0;
var IgxSwitchComponent = /** @class */ (function () {
    function IgxSwitchComponent() {
        this.id = "igx-switch-" + nextId++;
        this.disabled = false;
        this.tabindex = null;
        this.checked = false;
        this.change = new EventEmitter();
        this.focused = false;
        this._onTouchedCallback = noop;
        this._onChangeCallback = noop;
    }
    Object.defineProperty(IgxSwitchComponent.prototype, "labelId", {
        get: function () {
            return this.id + "_label";
        },
        enumerable: true,
        configurable: true
    });
    IgxSwitchComponent.prototype.onChange = function (event) {
        if (this.disabled) {
            return;
        }
        this.checked = !this.checked;
        this._onChangeCallback(this.checked);
        this.change.emit(event);
    };
    IgxSwitchComponent.prototype.onFocus = function (event) {
        this.focused = true;
    };
    IgxSwitchComponent.prototype.onBlur = function (event) {
        this.focused = false;
        this._onTouchedCallback();
    };
    IgxSwitchComponent.prototype.writeValue = function (value) {
        if (this.disabled) {
            return;
        }
        this._value = value;
        this.checked = this._value;
    };
    IgxSwitchComponent.prototype.registerOnChange = function (fn) { this._onChangeCallback = fn; };
    IgxSwitchComponent.prototype.registerOnTouched = function (fn) { this._onTouchedCallback = fn; };
    IgxSwitchComponent.decorators = [
        { type: Component, args: [{
                    providers: [{ provide: NG_VALUE_ACCESSOR, useExisting: IgxSwitchComponent, multi: true }],
                    selector: "igx-switch",
                    template: "<div class=\"igx-control\">     <input class=\"igx-control__switch\" #checkbox type=\"checkbox\" role=\"checkbox\"         [attr.id]=\"id\"         [attr.name]=\"name\"         [attr.value]=\"value\"         [attr.tabindex]=\"tabindex\"         [disabled]=\"disabled\"         [checked]=\"checked\"         [attr.aria-checked]=\"checked\"         [attr.aria-labelledby]=\"labelId\"         (change)=\"onChange($event)\"         (focus)=\"onFocus($event)\"         (blur)=\"onBlur($event)\">     <span class=\"igx-control__text\" [attr.id]=\"labelId\"><ng-content></ng-content>     </span>     <label class =\"igx-control__label\" [attr.for]=\"id\"></label> </div>"
                },] },
    ];
    /** @nocollapse */
    IgxSwitchComponent.ctorParameters = function () { return []; };
    IgxSwitchComponent.propDecorators = {
        "value": [{ type: Input },],
        "id": [{ type: Input },],
        "labelId": [{ type: Input },],
        "name": [{ type: Input },],
        "disabled": [{ type: Input },],
        "tabindex": [{ type: Input },],
        "checked": [{ type: Input },],
        "change": [{ type: Output },],
        "nativeCheckbox": [{ type: ViewChild, args: ["checkbox",] },],
    };
    return IgxSwitchComponent;
}());
export { IgxSwitchComponent };
var IgxSwitchModule = /** @class */ (function () {
    function IgxSwitchModule() {
    }
    IgxSwitchModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [IgxSwitchComponent],
                    exports: [IgxSwitchComponent]
                },] },
    ];
    /** @nocollapse */
    IgxSwitchModule.ctorParameters = function () { return []; };
    return IgxSwitchModule;
}());
export { IgxSwitchModule };
export { ɵ0 };
//# sourceMappingURL=switch.component.js.map